use strictures;
use Data::Query::ExprDeclare;
use Data::Query::Renderer::SQL::Naive;
use Devel::Dwarn;

my $renderer = Data::Query::Renderer::SQL::Naive->new;

sub render_expr {
  my ($sql, @bindp) = @{$renderer->render($_[0])};
  ($sql, map $_->{value}, @bindp);
}

DwarnL render_expr(SELECT { $_->foo, "bar" });
DwarnL render_expr(SELECT { $_->foo, "bar" } FROM { $_->baz });
DwarnL render_expr(SELECT { $_->foo } FROM { $_->baz, AS('quux') });
DwarnL render_expr(
  SELECT { $_->cd->name } FROM { $_->cds, AS('cd') } JOIN { $_->artists }
);
DwarnL render_expr(
  SELECT { $_->cd->name }
  FROM { $_->cds, AS 'cd' }
  JOIN { $_->artists, AS 'artist' }
    ON { $_->cd->artistid eq $_->artist->id }
);
DwarnL render_expr(
  SELECT { $_->artist->name }
  FROM { $_->artists, AS 'artist' }
  LEFT JOIN { $_->cds, AS 'cd' }
         ON { $_->cd->artistid eq $_->artist->id }
);
DwarnL render_expr(
  SELECT { $_->artist->name } WHERE { $_->artist->age > 25 }
);
DwarnL render_expr(
  SELECT { $_->cd->name }
  FROM { $_->cds, AS 'cd' }
  JOIN { $_->artists, AS 'artist' }
    ON { $_->cd->artistid eq $_->artist->id }
  WHERE { $_->artist->age > 25 }
);
